
import './App.css';
import {Router, Route, Link,Switch, Redirect} from 'react-router-dom';
import createHistory from "history/createBrowserHistory";
import React, {useState, useEffect, Component} from 'react';

import { Provider } from 'react-redux';
import {persistor, store} from './Redux/store.js'
import { PersistGate } from 'redux-persist/integration/react';
import PrivateRoute from './Route/privatRoute';



import { Button } from '@mui/material';
import MusicNoteIcon from '@mui/icons-material/MusicNote';
// import { Page404 } from './components/Page404/page404';
import ResponsiveAppBar from './components/header/header';
import BasicTable from './components/main/contentPage/cardPlay';
import SignIn from './components/loginPage';
import SignOn from './components/signOnPage';

import { baseURL } from './Redux/api';

import UserPage from './components/userPage';
import WrapperPlaylist from './components/main/contentPage/wrapperPlaylist';
import WrapperPlayer from './components/footer/wrapperPlayer';


    


const Menu = ()=>{
  return (
    <ul>
      <li><Button variant="text"><Link to="/playlist" >Playlist</Link></Button></li>
      <li><Button variant="text">d</Button></li>
      <li><Button variant="text">P</Button></li>
      <li><Button variant="text">P</Button></li>
    
    </ul>
    
  )
}

 

const history = createHistory()




function App() {
  return (
      <div className="App">
        <Provider store={store}>
        {/* <PersistGate loading={null} persistor={persistor}> */}
          <Router history={history}>
            
              <header><ResponsiveAppBar/></header>
              <main>
              <aside className='aside'>
              <Menu className="Menu" ></Menu>
              </aside>
              
              <Switch> 
                <PrivateRoute path="/playlist" component={WrapperPlaylist} exact></PrivateRoute>
                {/* <Route path="/404" component={}></Route> */}
                <PrivateRoute path="/playlist/:id" component={BasicTable}/>


                <Route path="/login" component={SignIn}></Route>
                <Route path="/registration" component={SignOn}></Route>
                <Route path="/user" component={UserPage}></Route>

              </Switch>



              </main>
              <footer className='footer'>
              <WrapperPlayer></WrapperPlayer>
              </footer>
            
          </Router>
        {/* </PersistGate>   */}
        </Provider>

          
      </div>
  );
}

export default App;

// const LoginForm = ({onLogin}) => {
//     const [login,setLogin] = useState("")
//     const [password,setPassword] = useState("")
//     const checkButton = !((login.length > 0) && (password.length > 0))
//     //тут надо два состояния - для логина и для пароля;
//     //кнопка логина должна быть disabled если одно из полей пустое
//     //по клику на кнопку запустить onLogin и передать туда 
//     //текущее состояние login и password
//     return (
//         <form>
//             <label>UserName</label>
//             <input type="text"  value={login} 
//             onChange ={e=>setLogin(e.target.value)}/>

//             <label>Password</label>
//             <input type="text"  value={password}
//             onChange={e=>setPassword(e.target.value)}/>

//             <input type="submit" value="Submit" onClick={()=>{
//                 onLogin({login,password})}} disabled={checkButton} />
//         </form>
//     )
// }
    
