import * as React from 'react';
import ImageList from '@mui/material/ImageList';
import ImageListItem from '@mui/material/ImageListItem';
import ImageListItemBar from '@mui/material/ImageListItemBar';
import { Link } from 'react-router-dom';

import {  useGetPlaylistQuery } from '../../../Redux/api';
import { useDispatch, useSelector } from 'react-redux';
import { setPlaylist } from '../../../Redux/toolkitSilce';
import { Grid,Box, Typography } from '@mui/material';
import { useHistory } from 'react-router-dom/cjs/react-router-dom.min';
import { ActionSetPlaylist  } from '../../../Redux/thunk';

export default function TitlebarBelowImageList({player,auth}) {
  const dispatch = useDispatch()
  const history = useHistory()
  const hookResult = useGetPlaylistQuery()
  const {data, isFetching} = hookResult
  // const imageUrl = "https://images.unsplash.com/photo-1551963831-b3b1ca40c98e"
  const imageUrl = "https://variety.com/wp-content/uploads/2021/09/Drake-publicity3-2021.jpg?w=1000"

  function PlayPlaylist (item) {
    dispatch(ActionSetPlaylist({item}))
    history.push(`/playlist/${item._id}`)
  }
 
  if(isFetching)
    return <h2>LOADING</h2>;
    
  return (<>
    <Grid container padding={1} spacing={1} direction='row' justifyContent="center" flexWrap="wrap">
    {data && data.PlaylistFind.map((item) => ( 
      item.name &&
      <Box  key={item._id}   onClick={(e) => PlayPlaylist(item) }  padding={1} margin={1}  
      sx={{
         display:"flex",width:"20%",
         flexDirection:"column",
         justifyContent:"center",alignItems:"center", 
         backgroundColor: "#242424"}}>
          {/* <Link to={`/playlist/${item?._id}`} key={item?._id} > */}
          <Box sx={{
            width: "100%",
            height:"auto",
            backgroundImage: `url(${imageUrl})`,
            backgroundSize: "cover",
            backgroundRepeat: "no-repeat",
            backgroundPosition: "center",
            flex: "1 0 auto",
            opacity:"90%",
         
            
          }}>
          <Typography >{item?.name ? item.name : "Playlist"}</Typography>
          </Box>
          <Box sx={{display: "flex", flex:"0 0 auto",flexDirection:"column",}} >
            <Typography>{item.name ? item?.name : "bohdan" }</Typography>
            <Typography>{item.description ? item?.description : "noDescription" }</Typography>
          </Box>
          {/* </Link> */}
      </Box>
      
      ))}
      
    </Grid>
    {/* <ImageList sx={{ width: "100%", height: "100%" }} cols={4} rowHeight={"auto"}  >
       
      {data && data.PlaylistFind.map((item) => ( 
      
        item?.name && 
        <ImageListItem key={item?._id } onClick={(e) => PlayPlaylist(item)}>
          <img
            src={ `https://images.unsplash.com/photo-1551963831-b3b1ca40c98e`}
            srcSet={`https://images.unsplash.com/photo-1551963831-b3b1ca40c98e`}
            alt={"alt"}
            loading="lazy"
          />
          <Link to={`/playlist/${item?._id}`} key={item?._id} >
          <ImageListItemBar
            title={item.description ? item?.description : "noDescription" }
            subtitle={<span>by: {item.name ? item?.name : "bohdan" }</span>}
            position="below"
          />
          </Link>
        </ImageListItem>
        
        
      ))}
    </ImageList> */}
    
  </>);
}

const itemData = [
  {
    img: 'https://images.unsplash.com/photo-1551963831-b3b1ca40c98e',
    title: 'Breakfast',
    author: '@bkristastucchio',
    
  },
  {
    img: 'https://images.unsplash.com/photo-1551782450-a2132b4ba21d',
    title: 'Burger',
    author: '@rollelflex_graphy726',
  },
  {
    img: 'https://images.unsplash.com/photo-1522770179533-24471fcdba45',
    title: 'Camera',
    author: '@helloimnik',
  },
  {
    img: 'https://images.unsplash.com/photo-1444418776041-9c7e33cc5a9c',
    title: 'Coffee',
    author: '@nolanissac',
  },
  {
    img: 'https://images.unsplash.com/photo-1533827432537-70133748f5c8',
    title: 'Hats',
    author: '@hjrc33',
  },
  {
    img: 'https://images.unsplash.com/photo-1558642452-9d2a7deb7f62',
    title: 'Honey',
    author: '@arwinneil',
  },
  {
    img: 'https://images.unsplash.com/photo-1516802273409-68526ee1bdd6',
    title: 'Basketball',
    author: '@tjdragotta',
  },
  {
    img: 'https://images.unsplash.com/photo-1518756131217-31eb79b20e8f',
    title: 'Fern',
    author: '@katie_wasserman',
  },
  {
    img: 'https://images.unsplash.com/photo-1597645587822-e99fa5d45d25',
    title: 'Mushrooms',
    author: '@silverdalex',
  },
  {
    img: 'https://images.unsplash.com/photo-1567306301408-9b74779a11af',
    title: 'Tomato basil',
    author: '@shelleypauls',
  },
  {
    img: 'https://images.unsplash.com/photo-1471357674240-e1a485acb3e1',
    title: 'Sea star',
    author: '@peterlaster',
  },
  {
    img: 'https://images.unsplash.com/photo-1589118949245-7d38baf380d6',
    title: 'Bike',
    author: '@southside_customs',
  },
];

