import * as React from 'react';
import Table from '@mui/material/Table';
import TableBody from '@mui/material/TableBody';
import TableCell from '@mui/material/TableCell';
import TableContainer from '@mui/material/TableContainer';
import TableHead from '@mui/material/TableHead';
import TableRow from '@mui/material/TableRow';
import Paper from '@mui/material/Paper';

import { IconCheckboxes } from './check';
import { CheckBox } from '@mui/icons-material';

import { useGetPlaylistOneQuery } from '../../../Redux/api';
import { baseURL } from '../../../Redux/api';
import { useParams } from 'react-router-dom';
import Music from './music';
import { useSelector } from 'react-redux';


function createData(name, calories, fat, carbs, protein) {
  return { name, calories, fat, carbs, protein };
}

const rows = [
  createData('Frozen yoghurt', 159, 6.0, 24, 4.0),
  createData('Ice cream sandwich', 237, 9.0, 37, 4.3),
  createData('Eclair', 262, 16.0, 24, 6.0),
  createData('Cupcake', 305, 3.7, 67, 4.3),
  createData('Gingerbread', 356, 16.0, 49, 3.9),
];


export default function BasicTable() {
  const player = useSelector(state => state.player)
  const {id : playlistID} = useParams()
  const hookResult = useGetPlaylistOneQuery(playlistID)
  const {data, isFetching} = hookResult
  let playlistIndex = 0
  if(isFetching)
    return <h2>LOADING</h2>
    
  return (
     <TableContainer component={Paper}>
       <Table sx={{ Width: "100%",height:"auto",bgcolor:"#2a2a2a" ,color:"white" }} aria-label="simple table">
         <TableHead>
           <TableRow>
             <TableCell><IconCheckboxes /><h3>Track</h3></TableCell>
             <TableCell align="right">name</TableCell>
             <TableCell align="right">Fat&nbsp;(g)</TableCell>
             <TableCell align="right">Carbs&nbsp;(g)</TableCell>
             <TableCell align="right">Protein&nbsp;(g)</TableCell>
           </TableRow>
         </TableHead>
         <TableBody>
          
         { player.playlist && player.playlist.tracks.map((row) =>(
          
            row?.url && <TableRow
               key={row._id}
               sx={{ '&:last-child td, &:last-child th': { border: 0 } }}
             >
            
               <TableCell key ={row._id }component="th" scope="row">
                {/* <audio controls src ={'http://player.node.ed.asmer.org.ua/' + row?.url}></audio> */}
                <Music key={row._id}  player={player} track = {row}  playlistIndex={playlistIndex++} active={row._id === player.track._id} ></Music>
               </TableCell>
               <TableCell align="right">{row?.originalFileName}</TableCell>
               <TableCell align="right">{row?._id}</TableCell>
               <TableCell align="right">{row?._id}</TableCell>
               <TableCell align="right">{row?._id}</TableCell>
             </TableRow>
           ))}
         </TableBody>
       </Table> 
     </TableContainer>
  );
}

